## flightgear 2020.3.6+dfsg

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.0)

include (CheckFunctionExists)
include (CheckVariableExists)
include (CheckCSourceCompiles)
include (CheckCXXSourceCompiles)
include (CheckIncludeFile)
include (CheckIncludeFileCXX)

if(COMMAND cmake_policy)
   if(POLICY CMP0054)
       cmake_policy(SET CMP0054 NEW)
   endif()
   # Mac RPATH policy
   if(POLICY CMP0042)
       cmake_policy(SET CMP0042 NEW)
   endif()

    # AUTOMOC/AUTOUIC on generated files policy. Since we only
    # generate resource files with fgrcc which don't use Qt,
    # we set those files source property. See the help for this
    # policy for more info
    if(POLICY CMP0071)
        cmake_policy(SET CMP0071 NEW)
    endif()

    # OpenGL VND policy : use the old definition for now, until we can audit this
    if(POLICY CMP0072)
        cmake_policy(SET CMP0072 OLD)
    endif()
endif()

message("CMAKE Build type: ${CMAKE_BUILD_TYPE}")
# Set a default build type if none was specified
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to 'Debug' as none was specified.")
  set(CMAKE_BUILD_TYPE Debug CACHE STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release"
    "MinSizeRel" "RelWithDebInfo")
endif()

if(NOT FG_BUILD_TYPE)
  message(STATUS "Setting build type to 'Dev' as none was specified.")
  set(FG_BUILD_TYPE Dev CACHE STRING "Choose the FlightGear build type" FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE FG_BUILD_TYPE PROPERTY STRINGS "Dev" "Nightly" "Release")
endif()

if(APPLE)
	set(CMAKE_INSTALL_RPATH "@loader_path/../Frameworks")
	# when building, don't use the install RPATH already
	# (but later on when installing)
	SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
endif()

# let's use & require C++11 - note these are only functional with CMake 3.1
# we do manual fallbacks for CMake 3.0 in the compilers section
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED YES)

set(CMAKE_OSX_DEPLOYMENT_TARGET "10.9" CACHE STRING "Minimum OS X deployment version")

project(FlightGear)

# Define SRC_PARENT_DIR as the parent directory of the project source directory
get_filename_component(SRC_PARENT_DIR ${PROJECT_SOURCE_DIR} DIRECTORY)

# We have some custom .cmake scripts not in the official distribution.
set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/CMakeModules;${CMAKE_MODULE_PATH}")
set_property(GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS TRUE)

# Warning when build is not an out-of-source build.
string(COMPARE EQUAL "${CMAKE_SOURCE_DIR}" "${CMAKE_BINARY_DIR}" InSourceBuild)
if(InSourceBuild)
    message(WARNING  "Avoid building inside the source tree!")
    message(WARNING  "Create a separate build directory instead (i.e. 'fgbuild') and call CMake from there: ")
    message(WARNING  "  mkdir ../fgbuild && cd ../fgbuild && cmake ${CMAKE_SOURCE_DIR}")
endif(InSourceBuild)

include(GNUInstallDirs)
# System detection/default settings
include( DetectDistro )
include( DetectBrowser )
include( ExportDebugSymbols )
set(CMAKE_DEBUG_POSTFIX          "d" CACHE STRING "add a postfix, usually d on windows")
set(CMAKE_RELEASE_POSTFIX        ""  CACHE STRING "add a postfix, usually empty on windows")
set(CMAKE_RELWITHDEBINFO_POSTFIX ""  CACHE STRING "add a postfix, usually empty on windows")
set(CMAKE_MINSIZEREL_POSTFIX     ""  CACHE STRING "add a postfix, usually empty on windows")

# read 'version' file into a variable (stripping any newlines or spaces)
file(READ flightgear-version versionFile)
if (NOT versionFile)
    message(FATAL_ERROR "Unable to determine FlightGear version. Version file is missing.")
endif()
string(STRIP "${versionFile}" FLIGHTGEAR_VERSION)
# add a dependency on the version file
set_property(DIRECTORY APPEND PROPERTY CMAKE_CONFIGURE_DEPENDS version)

# FlightGear packaging (to build a source tarball)
include( ConfigureCPack )

# FlightGear base package path
if (FG_DATA_DIR)
    message(STATUS "Using explicit data directory for base package: ${FG_DATA_DIR}")
elseif(IS_DIRECTORY "${SRC_PARENT_DIR}/fgdata")
    set(FG_DATA_DIR "${SRC_PARENT_DIR}/fgdata")
    message(STATUS "Using data directory for base package: ${FG_DATA_DIR}")
else()
    set(FG_DATA_DIR "${CMAKE_INSTALL_PREFIX}/lib/FlightGear" CACHE PATH "Default location where data files are located")
    message(STATUS "Using default data directory for base package:  ${FG_DATA_DIR}")
endif()

# Change the default build type to something fast
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release CACHE STRING
        "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
        FORCE)
endif(NOT CMAKE_BUILD_TYPE)

#####################################################################################
# Configure library search paths
#####################################################################################

IF(APPLE)
    set(EVENT_INPUT_DEFAULT 1)

    find_library(CORESERVICES_LIBRARY CoreServices)
    find_library(COCOA_LIBRARY Cocoa)
    list(APPEND PLATFORM_LIBS ${COCOA_LIBRARY} ${CORESERVICES_LIBRARY})
elseif(WIN32)
    set(EVENT_INPUT_DEFAULT 1)
    list(APPEND PLATFORM_LIBS "Shlwapi.lib")

    set(CMAKE_INSTALL_SYSTEM_RUNTIME_DESTINATION "bin")
    set(CMAKE_INSTALL_UCRT_LIBRARIES TRUE)
    include(InstallRequiredSystemLibraries)
    MESSAGE("Installing: ${CMAKE_INSTALL_SYSTEM_RUNTIME_LIBS}")

elseif(${CMAKE_SYSTEM_NAME} MATCHES "Linux" OR
	${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD" OR
	${CMAKE_SYSTEM_NAME} MATCHES "OpenBSD")
    find_package(Threads REQUIRED)
    find_package(X11 REQUIRED)

    set(USE_DBUS_DEFAULT 1)

    find_package(UDev QUIET)
    if(UDEV_FOUND)
        set(EVENT_INPUT_DEFAULT 1)
    endif(UDEV_FOUND)

    find_package(Speex)
    find_package(Speexdsp)
    if(SPEEX_FOUND AND SPEEXDSP_FOUND)
        set(SYSTEM_SPEEX_DEFAULT 1)
    endif(SPEEX_FOUND AND SPEEXDSP_FOUND)

    find_package(Gsm)
    if(GSM_FOUND)
        set(SYSTEM_GSM_DEFAULT 1)
    endif(GSM_FOUND)

    find_package(Flite)
    if(FLITE_FOUND)
        set(SYSTEM_FLITE_DEFAULT 1)
    endif()

    find_package(HtsEngine)
    if(HTS_ENGINE_FOUND)
        set(SYSTEM_HTS_ENGINE_DEFAULT 1)
    endif()
endif()

# FlightGear build options
option(LOGGING           "Set to ON to build FlightGear with logging support (default)" ON)
option(JSBSIM_TERRAIN    "Set to ON to build FlightGear with JSBSim terrain handling code" ON)
option(SP_FDMS           "Set to ON to build FlightGear with special-purpose FDMs" ON)
option(ENABLE_UIUC_MODEL "Set to ON to build FlightGear with UIUCModel FDM" ON)
option(ENABLE_LARCSIM    "Set to ON to build FlightGear with LaRCsim FDM" ON)
option(ENABLE_YASIM      "Set to ON to build FlightGear with YASIM FDM (default)" ON)
option(ENABLE_JSBSIM     "Set to ON to build FlightGear with JSBSim FDM (default)" ON)
option(EVENT_INPUT       "Set to ON to build FlightGear with event-based Input support" ${EVENT_INPUT_DEFAULT})
option(ENABLE_RTI        "Set to ON to build FlightGear with RTI support" OFF)
option(ENABLE_PROFILE    "Set to ON to build FlightGear with gperftools profiling support" OFF)
option(SYSTEM_SQLITE     "Set to ON to build FlightGear with the system's SQLite3 library" OFF)
option(ENABLE_IAX        "Set to ON to build FlightGear with IAXClient/fgcom built-in (default)" ON)
option(USE_DBUS          "Set to ON to build FlightGear with DBus screensaver interaction (default on Linux)" ${USE_DBUS_DEFAULT})
option(SYSTEM_SPEEX      "Set to ON to build IAXClient with the system's speex and speexdsp library" ${SYSTEM_SPEEX_DEFAULT})
option(SYSTEM_GSM        "Set to ON to build IAXClient with the system's GSM library" ${SYSTEM_GSM_DEFAULT})
option(SYSTEM_FLITE      "Set to ON to build Flightgear with the system's Flite library" ${SYSTEM_FLITE_DEFAULT})
option(SYSTEM_HTS_ENGINE "Set to ON to build Flightgear with the system's HTS Engine library" ${SYSTEM_HTS_ENGINE_DEFAULT})
option(SYSTEM_CPPUNIT    "Set to ON to build Flightgear with the system's CppUnit library")

# additional utilities
option(ENABLE_FGELEV     "Set to ON to build the fgelev application (default)" ON)
option(WITH_FGPANEL      "Set to ON to build the fgpanel application (default)" ON)
option(ENABLE_FGVIEWER   "Set to ON to build the fgviewer application (default)" ON)
option(ENABLE_GPSSMOOTH  "Set to ON to build the GPSsmooth application (default)" ON)
option(ENABLE_TERRASYNC  "Set to ON to build the terrasync application (default)" ON)
option(ENABLE_FGJS       "Set to ON to build the fgjs application (default)" ON)
option(ENABLE_JS_DEMO    "Set to ON to build the js_demo application (default)" ON)
option(ENABLE_METAR      "Set to ON to build the metar application (default)" ON)
option(ENABLE_STGMERGE   "Set to ON to build the stgmerge application (default)" OFF)
option(ENABLE_FGCOM      "Set to ON to build the FGCom application (default)" ON)
option(ENABLE_QT         "Set to ON to build the internal Qt launcher" ON)
option(ENABLE_TRAFFIC    "Set to ON to build the external traffic generator modules" ON)
option(ENABLE_FGQCANVAS  "Set to ON to build the Qt-based remote canvas application" OFF)
option(ENABLE_DEMCONVERT "Set to ON to build the dem conversion tool (default)" ON)
option(ENABLE_HID_INPUT  "Set to ON to build HID-based input code" ${EVENT_INPUT_DEFAULT})
option(ENABLE_PLIB_JOYSTICK  "Set to ON to enable legacy joystick code (default)" ON)
option(ENABLE_COMPOSITOR "Set to ON to enable the Compositor-based Viewer" OFF)
option(ENABLE_SWIFT      "Set to ON to build the swift module" ON)


# Test-suite options.
option(ENABLE_AUTOTESTING "Set to ON to execute the test suite after building the test_suite target (default)" ON)

include (DetectArch)

# when building an OSG with commit 15ec7e2ae7a8b983ecc44e1ce7363a9a9fa7da95
# applied, we can use better link options
option(OSG_FSTREAM_EXPORT_FIXED "Set to ON if the osgDB fstream export patch is applied" OFF)

if(LOGGING)
    # nothing
else()
    set(FG_NDEBUG 1)
endif()

if(JSBSIM_TERRAIN)
   set(JSBSIM_USE_GROUNDREACTIONS 1)
endif()

if(SP_FDMS)
    set(ENABLE_SP_FDM 1)
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "OpenBSD")
    include_directories(${PROJECT_SOURCE_DIR}/3rdparty/iaxclient/lib/libspeex/include)
endif()

if(ENABLE_FGCOM)
  set(ENABLE_IAX 1)
  include_directories(${PROJECT_SOURCE_DIR}/3rdparty/iaxclient/lib ) # for iaxclient.h
endif()

# Setup MSVC 3rd party directories
include( ConfigureMsvc3rdParty )

if(EVENT_INPUT)
    if(APPLE)
      add_definitions(-DWITH_EVENTINPUT)
      find_library(IOKIT_FRAMEWORK IOKit)
      list(APPEND EVENT_INPUT_LIBRARIES ${IOKIT_FRAMEWORK})
    elseif(CMAKE_SYSTEM_NAME MATCHES "Linux|FreeBSD|OpenBSD")
        if(NOT UDEV_FOUND)
            message(WARNING "UDev not found, event input is disabled!")
            set(EVENT_INPUT 0)

            # HIDraw backend for hidapi also needs UDev, so also force
            # HID-input to off in this scenario
            set(ENABLE_HID_INPUT 0)
        else()
            add_definitions(-DWITH_EVENTINPUT)
            set(EVENT_INPUT_LIBRARIES ${UDEV_LIBRARIES})
            message(STATUS "event-based input enabled. Using ${UDEV_LIBRARIES}")
        endif()
    else()
        add_definitions(-DWITH_EVENTINPUT)
    endif()

    if (ENABLE_HID_INPUT)
        message(STATUS "Enabling HID-API input")
        list(APPEND EVENT_INPUT_LIBRARIES hidapi)
    endif()
endif(EVENT_INPUT)

if (ENABLE_SWIFT)
# DBUS

    # our local FindDBus.cmake file uses pkg-config on non-Windows
    # we want to ensure our local prefixes are searched, so set this
    set(PKG_CONFIG_USE_CMAKE_PREFIX_PATH 1)

    # unfortunately CMAKE_INSTALL_PREFIX is not searched, so add that manually
    list(APPEND CMAKE_PREFIX_PATH ${CMAKE_INSTALL_PREFIX})

    find_package(DBus)

    #libevent
    find_package(LibEvent)

    if (DBUS_FOUND AND LIBEVENT_FOUND)
        message(STATUS "SWIFT support enabled")

=== icons/CMakeLists.txt ===
if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    install(FILES 16x16/apps/flightgear.png DESTINATION share/icons/hicolor/16x16/apps)
    install(FILES 22x22/apps/flightgear.png DESTINATION share/icons/hicolor/22x22/apps)
    install(FILES 24x24/apps/flightgear.png DESTINATION share/icons/hicolor/24x24/apps)
    install(FILES 32x32/apps/flightgear.png DESTINATION share/icons/hicolor/32x32/apps)
    install(FILES 48x48/apps/flightgear.png DESTINATION share/icons/hicolor/48x48/apps)
    install(FILES 64x64/apps/flightgear.png DESTINATION share/icons/hicolor/64x64/apps)
    install(FILES 128x128/apps/flightgear.png DESTINATION share/icons/hicolor/128x128/apps)
    install(FILES scalable/apps/flightgear.svg DESTINATION share/icons/hicolor/scalable/apps)
endif(${CMAKE_SYSTEM_NAME} MATCHES "Linux")

=== 3rdparty/cjson/CMakeLists.txt ===
include(FlightGearComponent)

set(SOURCES
	cJSON.c
	)

set(HEADERS
	cJSON.h
	)

flightgear_component(CJSON "${SOURCES}" "${HEADERS}")

=== 3rdparty/fonts/CMakeLists.txt ===

set (FNT_SOURCES
	fnt.cxx
	fntTXF.cxx
	fntBitmap.cxx
)

add_library(PLIBFont STATIC ${FNT_SOURCES})

target_link_libraries(PLIBFont SimGearCore)

target_include_directories(PLIBFont PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})

=== man/it/CMakeLists.txt ===
add_subdirectory(man1)
add_subdirectory(man5)

=== man/man5/CMakeLists.txt ===
include(GNUInstallDirs)
install(FILES fgfsrc.5 DESTINATION ${CMAKE_INSTALL_MANDIR}/man5
        COMPONENT doc)

=== src/Aircraft/CMakeLists.txt ===
include(FlightGearComponent)

set(SOURCES
	controls.cxx
	replay.cxx
	flightrecorder.cxx
    FlightHistory.cxx
		initialstate.cxx
	AircraftPerformance.cxx
	)

set(HEADERS
	controls.hxx
	replay.hxx
	flightrecorder.hxx
    FlightHistory.hxx
		initialstate.hxx
	AircraftPerformance.hxx
	)


flightgear_component(Aircraft "${SOURCES}" "${HEADERS}")

=== src/FDM/CMakeLists.txt ===
include(FlightGearComponent)

if(SP_FDMS)
set(SP_FDM_SOURCES
	SP/ACMS.cxx
	SP/ADA.cxx
	SP/Balloon.cxx
	SP/BalloonSim.cpp
	SP/MagicCarpet.cxx
    SP/AISim.cpp
	)
set (SP_FDM_HEADERS
	SP/ACMS.hxx
	SP/ADA.hxx
	SP/MagicCarpet.hxx
	SP/Balloon.h
	SP/BalloonSim.h
	SP/AISim.hpp
	)
endif()

set(UIUC_SOURCES
	uiuc_1DdataFileReader.cpp
	uiuc_1Dinterpolation.cpp
	uiuc_2DdataFileReader.cpp
	uiuc_2Dinterpolation.cpp
	uiuc_3Dinterpolation.cpp
	uiuc_aerodeflections.cpp
	uiuc_alh_ap.cpp
	uiuc_auto_pilot.cpp
	uiuc_betaprobe.cpp
	uiuc_coef_drag.cpp
	uiuc_coef_lift.cpp
	uiuc_coef_pitch.cpp
	uiuc_coef_roll.cpp
	uiuc_coef_sideforce.cpp
	uiuc_coef_yaw.cpp
	uiuc_coefficients.cpp
	uiuc_controlInput.cpp
	uiuc_convert.cpp
	uiuc_engine.cpp
	uiuc_find_position.cpp
	uiuc_flapdata.cpp
	uiuc_fog.cpp
	uiuc_gear.cpp
	uiuc_get_flapper.cpp
	uiuc_getwind.cpp
	uiuc_hh_ap.cpp
	uiuc_ice.cpp
	uiuc_iceboot.cpp
	uiuc_iced_nonlin.cpp
	uiuc_icing_demo.cpp
	uiuc_initializemaps.cpp
	uiuc_map_CD.cpp
	uiuc_map_CL.cpp
	uiuc_map_CY.cpp
	uiuc_map_Cm.cpp
	uiuc_map_Cn.cpp
	uiuc_map_Croll.cpp
	uiuc_map_controlSurface.cpp
	uiuc_map_engine.cpp
	uiuc_map_fog.cpp
	uiuc_map_gear.cpp
	uiuc_map_geometry.cpp
	uiuc_map_ice.cpp
	uiuc_map_init.cpp
	uiuc_map_keyword.cpp
	uiuc_map_mass.cpp
	uiuc_map_misc.cpp
	uiuc_map_record1.cpp
	uiuc_map_record2.cpp
	uiuc_map_record3.cpp
	uiuc_map_record4.cpp
	uiuc_map_record5.cpp
	uiuc_map_record6.cpp
	uiuc_menu.cpp
	uiuc_menu_CD.cpp
	uiuc_menu_CL.cpp
	uiuc_menu_CY.cpp
	uiuc_menu_Cm.cpp
	uiuc_menu_Cn.cpp
	uiuc_menu_Croll.cpp
	uiuc_menu_controlSurface.cpp
	uiuc_menu_engine.cpp
	uiuc_menu_fog.cpp
	uiuc_menu_functions.cpp
	uiuc_menu_gear.cpp
	uiuc_menu_geometry.cpp
	uiuc_menu_ice.cpp
	uiuc_menu_init.cpp
	uiuc_menu_mass.cpp
	uiuc_menu_misc.cpp
	uiuc_menu_record.cpp
	uiuc_pah_ap.cpp
	uiuc_parsefile.cpp
	uiuc_rah_ap.cpp
	uiuc_recorder.cpp
	uiuc_warnings_errors.cpp
	uiuc_wrapper.cpp
	)
	
set(LARCSIM_SOURCES
    atmos_62.c
    basic_aero.c
    basic_engine.c
    basic_gear.c
    basic_init.c
    c172_aero.c
    c172_engine.c
    c172_gear.c
    c172_init.c
    cherokee_aero.c
    cherokee_engine.c
    cherokee_gear.c
    cherokee_init.c
    default_model_routines.c
    ls_accel.c
    ls_aux.c
    ls_geodesy.c
    ls_gravity.c
    ls_init.c
    ls_interface.c
    ls_model.c
    ls_step.c
    navion_aero.c
    navion_engine.c
    navion_gear.c
    navion_init.c
    uiuc_aero.c
    IO360.cxx
    LaRCsim.cxx
    LaRCsimIC.cxx
    )
	
set(SOURCES
	NullFDM.cxx
	UFO.cxx
	fdm_shell.cxx
	flight.cxx
	flightProperties.cxx
	TankProperties.cxx
	groundcache.cxx
	${SP_FDM_SOURCES}
	ExternalNet/ExternalNet.cxx
	ExternalPipe/ExternalPipe.cxx
	AIWake/AircraftMesh.cxx
	AIWake/WakeMesh.cxx
	AIWake/AeroElement.cxx
	AIWake/AIWakeGroup.cxx
	LaRCsim/ls_matrix.c
	)

set(HEADERS
	NullFDM.hxx
	TankProperties.hxx
	UFO.hxx
	fdm_shell.hxx
	flight.hxx
	flightProperties.hxx
	groundcache.hxx
	${SP_FDM_HEADERS}
	)

if(ENABLE_UIUC_MODEL)
	foreach(component ${UIUC_SOURCES})
		list(APPEND SOURCES "UIUCModel/${component}")
	endforeach()
endif()

if(ENABLE_LARCSIM)
	foreach(component ${LARCSIM_SOURCES})
		list(APPEND SOURCES "LaRCsim/${component}")
	endforeach()
endif()

flightgear_component(FDM "${SOURCES}" "${HEADERS}")

if(ENABLE_YASIM)
	add_subdirectory(YASim)
endif()


if(ENABLE_JSBSIM)
    add_subdirectory(JSBSim)
    
    # FIXME - push this down once JSBSim doesn't expose private headers
    include_directories(${PROJECT_SOURCE_DIR}/src/FDM/JSBSim)
endif()

=== src/GUI/CMakeLists.txt ===
include(FlightGearComponent)

set(SOURCES
  AirportList.cxx
  CanvasWidget.cxx
  MapWidget.cxx
  WaypointList.cxx
  dialog.cxx
  FGPUIDialog.cxx
  fonts.cxx
  gui.cxx
  gui_funcs.cxx
  layout-props.cxx
  layout.cxx
  menubar.cxx
  FGPUIMenuBar.cxx
  new_gui.cxx
  property_list.cxx
  FGFontCache.cxx
  FGColor.cxx
    FileDialog.cxx
    PUIFileDialog.cxx
    MouseCursor.cxx
    MessageBox.cxx
  )

set(HEADERS
  AirportList.hxx
  CanvasWidget.hxx
  MapWidget.hxx
  WaypointList.hxx
  dialog.hxx
  FGPUIDialog.hxx
  gui.h
  layout.hxx
  menubar.hxx
  FGPUIMenuBar.hxx
  new_gui.hxx
  property_list.hxx
  FGFontCache.hxx
  FGColor.hxx
    FileDialog.hxx
    PUIFileDialog.hxx
    MouseCursor.hxx
    MessageBox.hxx
  )

if(WIN32)
  list(APPEND HEADERS WindowsMouseCursor.hxx
            FGWindowsMenuBar.hxx
            WindowsFileDialog.hxx)
  list(APPEND SOURCES WindowsMouseCursor.cxx
            FGWindowsMenuBar.cxx
            WindowsFileDialog.cxx)
endif()

if (APPLE)
    list(APPEND HEADERS FGCocoaMenuBar.hxx
        CocoaFileDialog.hxx
        CocoaMouseCursor.hxx
        CocoaHelpers.h
        CocoaHelpers_private.h)
    list(APPEND SOURCES FGCocoaMenuBar.mm
        CocoaFileDialog.mm
        CocoaMouseCursor.mm
        CocoaHelpers.mm)
endif()

if (HAVE_QT)
    qt5_wrap_ui(uic_sources SetupRootDialog.ui
                            InstallSceneryDialog.ui
                            )
    qt5_add_resources(qrc_sources resources.qrc)

    if (TARGET fgfs_qm_files)
      qt5_add_resources(qrc_sources ${PROJECT_BINARY_DIR}/translations.qrc)
    endif()

    add_library(fglauncher QtLauncher.cxx
                            QtLauncher.hxx
                            LauncherMainWindow.hxx
                            LauncherMainWindow.cxx
                            BaseDiagram.cxx
                            BaseDiagram.hxx
                            AirportDiagram.cxx
                            AirportDiagram.hxx
                            CarrierDiagram.cxx
                            CarrierDiagram.hxx
                            NavaidDiagram.cxx
                            NavaidDiagram.hxx
                            SetupRootDialog.cxx
                            SetupRootDialog.hxx
                            AircraftModel.hxx
                            AircraftModel.cxx
                            CatalogListModel.cxx
                            CatalogListModel.hxx
                            QtMessageBox.cxx
                            QtMessageBox.hxx
                            QtFileDialog.cxx
                            QtFileDialog.hxx
                            InstallSceneryDialog.hxx
                            InstallSceneryDialog.cxx
                            LocationController.cxx
                            LocationController.hxx
                            LauncherArgumentTokenizer.cxx
                            LauncherArgumentTokenizer.hxx
                            AircraftSearchFilterModel.cxx
                            AircraftSearchFilterModel.hxx
                            DefaultAircraftLocator.cxx
                            DefaultAircraftLocator.hxx
                            LaunchConfig.cxx
                            LaunchConfig.hxx
                            MPServersModel.cpp
                            MPServersModel.h
                            RecentAircraftModel.cxx
                            RecentAircraftModel.hxx
                            RecentLocationsModel.cxx
                            RecentLocationsModel.hxx
                            LauncherController.cxx
                            LauncherController.hxx
                            AddOnsController.cxx
                            AddOnsController.hxx
                            AddonsModel.cxx
                            AddonsModel.hxx
                            PixmapImageItem.cxx
                            PixmapImageItem.hxx
                            PathListModel.cxx
                            PathListModel.hxx
                            CarriersLocationModel.cxx
                            CarriersLocationModel.hxx
                            FavouriteAircraftData.cxx
                            FavouriteAircraftData.hxx
                            UpdateChecker.cxx
                            UpdateChecker.hxx
                            LauncherPackageDelegate.hxx
                            LauncherPackageDelegate.cxx
                            LauncherNotificationsController.hxx
                            LauncherNotificationsController.cxx
                            ${uic_sources}
                            ${qrc_sources}
                            ${qml_sources})

    set_property(TARGET fglauncher PROPERTY AUTOMOC ON)
    target_include_directories(fglauncher PRIVATE ${PROJECT_BINARY_DIR}/src/GUI)
    target_link_libraries(fglauncher Qt5::Core Qt5::Widgets Qt5::Network Qt5::Qml Qt5::Quick Qt5::Svg SimGearCore)

    if (ENABLE_QQ_UI)
      set(QQUI_SOURCES 
        QQuickDrawable.cxx
        QQuickDrawable.hxx)
    endif()

    add_library(fgqmlui 
                        QtQuickFGCanvasItem.cxx
                        QtQuickFGCanvasItem.hxx
                        PropertyItemModel.cxx
                        PropertyItemModel.hxx
                        FGQmlInstance.cxx
                        FGQmlInstance.hxx
                        FGQmlPropertyNode.cxx
                        FGQmlPropertyNode.hxx
                        QmlAircraftInfo.cxx
                        QmlAircraftInfo.hxx
                        LocalAircraftCache.cxx
                        LocalAircraftCache.hxx
                        PreviewImageItem.cxx
                        PreviewImageItem.hxx
                        ThumbnailImageItem.cxx
                        ThumbnailImageItem.hxx
                        QmlPropertyModel.hxx
                        QmlPropertyModel.cxx
                        QmlPositioned.hxx
                        QmlPositioned.cxx
                        QmlNavCacheWrapper.hxx
                        QmlNavCacheWrapper.cxx
                        QmlRadioButtonHelper.cxx
                        QmlRadioButtonHelper.hxx
                        QtHelpers.hxx
                        QtHelpers.cxx
                        UnitsModel.cxx
                        UnitsModel.hxx
                        NavaidSearchModel.hxx
                        NavaidSearchModel.cxx
                        FlightPlanController.cxx
                        FlightPlanController.hxx
                        RouteDiagram.cxx
                        RouteDiagram.hxx
                        StackController.cxx
                        StackController.hxx
                        ModelDataExtractor.cxx
                        ModelDataExtractor.hxx
                        HoverArea.cxx
                        HoverArea.hxx
                        FGQQWindowManager.cxx
                        FGQQWindowManager.hxx
                        PathUrlHelper.cxx
                        PathUrlHelper.hxx
                        DialogStateController.cxx
                        DialogStateController.hxx
                        GettingStartedTip.hxx
                        GettingStartedTip.cxx
                        GettingStartedTipsController.cxx
                        GettingStartedTipsController.hxx
                        TipBackgroundBox.cxx
                        TipBackgroundBox.hxx
                        GettingStartedScope.hxx
                        GettingStartedScope.cxx
                        ${QQUI_SOURCES}
                        )

    set_property(TARGET fgqmlui PROPERTY AUTOMOC ON)
    target_link_libraries(fgqmlui Qt5::Quick Qt5::Widgets Qt5::Network Qt5::Qml Qt5::Gui SimGearCore)
    target_include_directories(fgqmlui PRIVATE ${PROJECT_BINARY_DIR}/src/GUI)

    if (ENABLE_QQ_UI)
      # this is a headers-only dependency, so we can include <private/qopenglcontext_p.h>
      target_link_libraries(fgqmlui Qt5::GuiPrivate)
    endif()

    if (TARGET fgfs_qm_files)
      add_dependencies(fglauncher fgfs_qm_files)
      add_dependencies(fgqmlui fgfs_qm_files)
    endif()

endif()


flightgear_component(GUI "${SOURCES}" "${HEADERS}")

=== src/Instrumentation/CMakeLists.txt ===
include(FlightGearComponent)

set(SOURCES
    AbstractInstrument.cxx
    adf.cxx
    airspeed_indicator.cxx
    altimeter.cxx
    attitude_indicator.cxx
    clock.cxx
    dclgps.cxx
    dme.cxx
    gps.cxx
    gsdi.cxx
    gyro.cxx
    heading_indicator.cxx
    heading_indicator_dg.cxx
    heading_indicator_fg.cxx
    inst_vertical_speed_indicator.cxx
    instrument_mgr.cxx
    kr_87.cxx
    mag_compass.cxx
    marker_beacon.cxx
    mk_viii.cxx
    mrg.cxx
    navradio.cxx
    newnavradio.cxx
    commradio.cxx
    rad_alt.cxx
    rnav_waypt_controller.cxx
    slip_skid_ball.cxx
    tacan.cxx
    tcas.cxx
    transponder.cxx
    turn_indicator.cxx
    vertical_speed_indicator.cxx
    HUD/HUD.cxx
    HUD/HUD_dial.cxx
    HUD/HUD_gauge.cxx
    HUD/HUD_instrument.cxx
    HUD/HUD_label.cxx
    HUD/HUD_ladder.cxx
    HUD/HUD_misc.cxx
    HUD/HUD_runway.cxx
    HUD/HUD_scale.cxx
    HUD/HUD_tape.cxx
    HUD/HUD_tbi.cxx
    KLN89/kln89.cxx
    KLN89/kln89_page.cxx
    KLN89/kln89_page_act.cxx
    KLN89/kln89_page_apt.cxx
    KLN89/kln89_page_cal.cxx
    KLN89/kln89_page_dir.cxx
    KLN89/kln89_page_fpl.cxx
    KLN89/kln89_page_int.cxx
    KLN89/kln89_page_nav.cxx
    KLN89/kln89_page_ndb.cxx
    KLN89/kln89_page_nrst.cxx
    KLN89/kln89_page_oth.cxx
    KLN89/kln89_page_set.cxx
    KLN89/kln89_page_usr.cxx
    KLN89/kln89_page_vor.cxx
    KLN89/kln89_page_alt.cxx
    )

set(HEADERS
    AbstractInstrument.hxx
    adf.hxx
    airspeed_indicator.hxx
    altimeter.hxx
    attitude_indicator.hxx
    clock.hxx
    dclgps.hxx
    dme.hxx
    gps.hxx
    gsdi.hxx
    gyro.hxx
    heading_indicator.hxx
    heading_indicator_dg.hxx
    heading_indicator_fg.hxx
    inst_vertical_speed_indicator.hxx
    instrument_mgr.hxx
    kr_87.hxx
    mag_compass.hxx
    marker_beacon.hxx
    mk_viii.hxx
    mrg.hxx
    navradio.hxx
    newnavradio.hxx
    commradio.hxx
    rad_alt.hxx
    rnav_waypt_controller.hxx
    slip_skid_ball.hxx
    tacan.hxx
    tcas.hxx
    transponder.hxx
    turn_indicator.hxx
    vertical_speed_indicator.hxx
    HUD/HUD.hxx
    HUD/HUD_private.hxx
    KLN89/kln89.hxx
    KLN89/kln89_page.hxx
    KLN89/kln89_page_act.hxx
    KLN89/kln89_page_apt.hxx
    KLN89/kln89_page_cal.hxx
    KLN89/kln89_page_dir.hxx
    KLN89/kln89_page_fpl.hxx
    KLN89/kln89_page_int.hxx
    KLN89/kln89_page_nav.hxx
    KLN89/kln89_page_ndb.hxx
    KLN89/kln89_page_nrst.hxx
    KLN89/kln89_page_oth.hxx
    KLN89/kln89_page_set.hxx
    KLN89/kln89_page_usr.hxx
    KLN89/kln89_page_vor.hxx
    KLN89/kln89_page_alt.hxx
    )

flightgear_component(Instruments "${SOURCES}" "${HEADERS}")

=== src/Main/CMakeLists.txt ===
# CMake module includes.
include(FlightGearComponent)
include(SetupFGFSBundle)
include(SetupFGFSEmbeddedResources)
include(SetupFGFSIncludes)
include(SetupFGFSLibraries)
include(SetupMSVCGrouping)

# Set up the Main FG file sources and headers (excluding bootstrap.cxx and its main() function).
if(MSVC)
    set(MS_RESOURCE_FILE flightgear.rc)
endif(MSVC)

set(SOURCES
    fg_commands.cxx
    fg_init.cxx
    fg_io.cxx
    fg_os_common.cxx
    fg_scene_commands.cxx
    fg_props.cxx
    FGInterpolator.cxx
    globals.cxx
    locale.cxx
    logger.cxx
    main.cxx
    options.cxx
    positioninit.cxx
    screensaver_control.cxx
    subsystemFactory.cxx
    util.cxx
    XLIFFParser.cxx
    sentryIntegration.cxx
    ${MS_RESOURCE_FILE}
)

set(HEADERS
    AircraftDirVisitorBase.hxx
    fg_commands.hxx
    fg_init.hxx
    fg_io.hxx
    fg_props.hxx
    FGInterpolator.hxx
    globals.hxx
    locale.hxx
    logger.hxx
    main.hxx
    options.hxx
    positioninit.hxx
    screensaver_control.hxx
    subsystemFactory.hxx
    util.hxx
    XLIFFParser.hxx
    sentryIntegration.hxx
)

flightgear_component(Main "${SOURCES}" "${HEADERS}")

# The main() function.
set(MAIN_SOURCE
    bootstrap.cxx
)

# Set up the embedded resources.
setup_fgfs_embedded_resources()

# Sort the sources and headers for MSVC.
setup_msvc_grouping()

# Additional search paths for includes.
setup_fgfs_includes()

# All sources and headers to be built into fgfs.
get_property(FG_SOURCES GLOBAL PROPERTY FG_SOURCES)
get_property(FG_HEADERS GLOBAL PROPERTY FG_HEADERS)
get_property(EMBEDDED_RESOURCE_SOURCES GLOBAL PROPERTY EMBEDDED_RESOURCE_SOURCES)
get_property(EMBEDDED_RESOURCE_HEADERS GLOBAL PROPERTY EMBEDDED_RESOURCE_HEADERS)

set_source_files_properties(${EMBEDDED_RESOURCE_SOURCES} PROPERTIES GENERATED TRUE)
set_source_files_properties(${EMBEDDED_RESOURCE_HEADERS} PROPERTIES GENERATED TRUE)

# important we pass WIN32 here so the console is optional. Other
# platforms ignore this option. If a console is needed we allocate
# it manually via AllocConsole()
# similarly pass MACOSX_BUNDLE so we generate a .app on Mac
add_executable(fgfs
    WIN32
    MACOSX_BUNDLE
    ${MAIN_SOURCE}
    ${FG_SOURCES}
    ${FG_HEADERS}
    ${EMBEDDED_RESOURCE_SOURCES}
    ${EMBEDDED_RESOURCE_HEADERS}
)

add_dependencies(fgfs buildId embeddedresources)
# explicitly disable automoc for main fgfs target
set_property(TARGET fgfs PROPERTY AUTOMOC OFF)

# MacOSX bundle packaging
if(APPLE)
    setup_fgfs_bundle(fgfs)
endif()

# Set up the target links.
setup_fgfs_libraries(fgfs)
export_debug_symbols(fgfs)

if (APPLE)
    install(TARGETS fgfs BUNDLE DESTINATION .)
else()
    install(TARGETS fgfs RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

if (TARGET sentry::sentry)
    target_link_libraries(fgfs sentry::sentry)
endif()

if (TARGET sentry_crashpad::handler)
    if (APPLE)
        # install inside the bundle
        install(FILES $<TARGET_FILE:sentry_crashpad::handler> DESTINATION fgfs.app/Contents/MacOS OPTIONAL)
    else()
        # install in the bin-dir, next to the application binary
        install(FILES $<TARGET_FILE:sentry_crashpad::handler> DESTINATION ${CMAKE_INSTALL_BINDIR} OPTIONAL)
    endif()
endif()

if(ENABLE_METAR)
    add_executable(metar metar_main.cxx)
    target_link_libraries(metar
        SimGearScene SimGearCore
        ${PLATFORM_LIBS}
    )

    install(TARGETS metar RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

if (MSVC)
  file(TO_NATIVE_PATH "${FG_QT_BIN_DIR}" _qt5_bin_dir_native)
  file(TO_NATIVE_PATH "${MSVC_3RDPARTY_ROOT}/${MSVC_3RDPARTY_DIR}/bin" _msvc_3rdparty_bin_dir)
  file(TO_NATIVE_PATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR}" _install_bin_dir)

  set_property(TARGET fgfs PROPERTY
  VS_GLOBAL_LocalDebuggerEnvironment "PATH=${_install_bin_dir};${_msvc_3rdparty_bin_dir};${_qt5_bin_dir_native}")
endif()

if (FG_QT_ROOT_DIR)
    # for QtPlatformHeaders
    target_include_directories(fgfs PRIVATE ${FG_QT_ROOT_DIR}/include)
endif()

=== src/MultiPlayer/CMakeLists.txt ===
include(FlightGearComponent)

set(SOURCES
	multiplaymgr.cxx
	tiny_xdr.cxx
        MPServerResolver.cxx
	)

set(HEADERS
	multiplaymgr.hxx
	tiny_xdr.hxx
        MPServerResolver.hxx
	)
    	
flightgear_component(MultiPlayer "${SOURCES}" "${HEADERS}")

=== debian/changelog ===
flightgear (1:2020.3.6+dfsg-1build1) jammy; urgency=medium

  * No-change rebuild against Qt 5.15.3.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Thu, 17 Mar 2022 18:36:14 +0300

flightgear (1:2020.3.6+dfsg-1) unstable; urgency=medium

  * New upstream release 2020.3.6+dfsg
  * Refresh patch spelling_20160206.patch
  * Adjust dependencies on data packages

 -- Markus Wanner <markus@bluegap.ch>  Sat, 13 Feb 2021 22:18:23 +0100

flightgear (1:2020.3.5+dfsg-1) unstable; urgency=medium

  * New upstream release 2020.3.5+dfsg
  * Add patch 0011-test-compilation-fix.patch.

 -- Markus Wanner <markus@bluegap.ch>  Mon, 28 Dec 2020 09:46:49 +0100

flightgear (1:2020.3.4+dfsg-1) unstable; urgency=medium

  * New upstream version 2020.3.4+dfsg
    - Refresh patches
  * Update Standards-Version to 4.5.1, no changes needed
  * Update versioned Build-Dependencies to new data packages

 -- Dr. Tobias Quathamer <toddy@debian.org>  Tue, 08 Dec 2020 23:44:10 +0100

=== debian/control ===
Source: flightgear
Maintainer: Debian FlightGear Crew <team+flightgear@tracker.debian.org>
Uploaders: Ove Kaaven <ovek@arcticnet.no>,
           Markus Wanner <markus@bluegap.ch>,
           Dr. Tobias Quathamer <toddy@debian.org>
Section: games
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               flightgear-data-ai (>= 1:2020.3.6~),
               flightgear-data-base (>= 1:2020.3.6~),
               flite1-dev,
               libboost-dev,
               libcurl4-gnutls-dev,
               libdbus-1-dev,
               libexpat1-dev,
               libgl1-mesa-dev,
               libglu1-mesa-dev,
               libgsm1-dev,
               libhtsengine-dev,
               libopenal-dev,
               libopenscenegraph-dev,
               libplib-dev,
               libqt5svg5-dev,
               libsimgear-dev (<= 1:2020.3.999),
               libsimgear-dev (>> 1:2020.3.6~),
               libspeex-dev,
               libspeexdsp-dev,
               libsqlite3-dev,
               libudev-dev [linux-any],
               libudns-dev,
               libusbhid-dev [kfreebsd-any],
               libx11-dev,
               qtbase5-dev [!armel !armhf],
               qtbase5-private-dev [!armel !armhf],
               qtdeclarative5-dev [!armel !armhf],
               qtdeclarative5-private-dev [!armel !armhf],
               qttools5-dev,
               zlib1g-dev
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/debian/flightgear
Vcs-Git: https://salsa.debian.org/debian/flightgear.git
Homepage: https://home.flightgear.org/
Rules-Requires-Root: no

Package: flightgear
Architecture: any
Depends: flightgear-data-all (>= 1:2020.3.6~),
         qml-module-qtquick-window2 [!armel !armhf],
         qml-module-qtquick2 [!armel !armhf],
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: flightgear-phi
Conflicts: metar
Description: Flight Gear Flight Simulator
 FlightGear Flight Simulator (often shortened to FlightGear or FGFS)
 is a sophisticated free, completely open-source flight simulator
 framework, created by volunteers.
 .
 This package contains the runtime binaries.

## flightgear 2020.3.16%2Bdfsg

=== src/Traffic/CMakeLists.txt ===
include(FlightGearComponent)

set(SOURCES
	SchedFlight.cxx
	Schedule.cxx
	TrafficMgr.cxx
	)

set(HEADERS
	SchedFlight.hxx
	Schedule.hxx
	TrafficMgr.hxx
)


flightgear_component(Traffic "${SOURCES}" "${HEADERS}")
